Skip to main content

Find the Triple - Hard

Problem : Given 3 Integer Arrays A,B,C. Find out if an instance exists where A[i] + B[j] + C[k] == 0.

Very deceptive question but very similar to the 3SUM Problem. The Naive solution is O(n^3). If you're a little clever, you can do a O(n^2 logn). At this point, you might give up assuming that this is pretty efficient. But then there is also a O(n^2) solution as well!

Let's go from worst to best.

The Naive solution is trivial.
FIND-TRIPLET-1(A,B,C)
FOR i = 1 to len(A)
FOR j = 1 to len(B)
FOR k = 1 to len(C)
if A[i] + B[j] + C[k] == 0
RETURN {A[i],B[j],C[k]}
RETURN {}
END-FUNCTION
view raw gistfile1.txt hosted with ❤ by GitHub
Try every combination until we hit a solution, if we don't there is no solution.

So let's try to speed things up a bit, since the solution is already O(n^3), I think we can afford to sort any of the  arrays since nlogn = o(n^3). Therefore, we cleverly sort the Array C. Now in the third loop we replace the linear scan with a binary search to find (-A[i]-B[j]). The complexity is now reduced to O(n^2 logn)

FIND-TRIPLET-2(A,B,C)
SORT(C)
FOR i = 1 to len(A)
FOR j = 1 to len(B)
k = BINARY-SEARCH(C,-A[i]-B[j])
if k > 0
RETURN {A[i],B[j],C[k]}
RETURN {}
END FUNCTION
view raw gistfile1.txt hosted with ❤ by GitHub
At this point, you've leveled up. The next algorithm might not be immediately apparent but works. In fact the method is similar to the O(n^2) solution to 3SUM.

FIND-TRIPLET-3(A,B,C) // A[1..len(A)]
SORT(A)
SORT(B)
FOR i = 1 to len(C)
left = 1
right = len(B)
WHILE left <= len(A) AND right > 0
SUM = A[left] + B[right] + C[i]
IF SUM == 0
return {A[left] , B[right] , C[i]}
ELSE IF SUM < 0
left = left + 1
ELSE
right = right - 1
END-WHILE
RETURN {}
END FUNCTION
view raw gistfile1.txt hosted with ❤ by GitHub
Java Code for all these solutions can be found here.

Comments

Popular posts from this blog

Find Increasing Triplet Subsequence - Medium

Problem - Given an integer array A[1..n], find an instance of i,j,k where 0 < i < j < k <= n and A[i] < A[j] < A[k]. Let's start with the obvious solution, bruteforce every three element combination until we find a solution. Let's try to reduce this by searching left and right for each element, we search left for an element smaller than the current one, towards the right an element greater than the current one. When we find an element that has both such elements, we found the solution. The complexity of this solution is O(n^2). To reduce this even further, One can simply apply the longest increasing subsequence algorithm and break when we get an LIS of length 3. But the best algorithm that can find an LIS is O(nlogn) with O( n ) space . An O(nlogn) algorithm seems like an overkill! Can this be done in linear time? The Algorithm: We iterate over the array and keep track of two things. The minimum value iterated over (min) The minimum increa...

Find the Quadruplets - Hard

Problem - Given 4 arrays A,B,C,D. Find out if there exists an instance where A[i] + B[j] + C[k] + D[l] = 0 Like the Find the Triple problem, we're going to develop 4 algorithms to solve this. Starting with the naive O(n^4) solution. Then we proceed to eliminate the inner-most loop with a Binary Search, reducing the complexity to O(n^3 logn) Now, we replace the last 2 loops with the left-right traversal we did in the previous 3 posts. Now the complexity is O(n^3). Finally, we reduce the complexity to O(n^2 logn) at the cost of O(n^2) Space Complexity. We store every combination of A[i] + B[j] and store it in AB[]. Similarly we make CD[] out of C[i] + D[j]. So, AB = A x B CD = C x D We then sort AB and CD (which costs O(n^2 log(n^2)) ~ O(n^2 logn) ) and then run a left-right linear Algorithm on AB and CD. (Note : Their size is of the order O(n^2)) So the overall complexity is due to sorting the large array of size n^2. which is O(n^2 logn).

Dijkstra's algorithm - Part 1 - Tutorial

This will be a 3 Part series of posts where I will be implementing the Dijkstra's Shortest Path algorithm in Python. The three parts will be 1) Representing the Graph 2) Priority Queue 3) The Algorithm To represent a graph we'll be using an  Adjacency List . Another alternative is using an Adjacency Matrix, but for a sparse graph an Adjacency List is more efficient. Adjacency List An Adjacency List is usually represented as a HashTable (or an Array) where an entry at `u` contains a Linked List. The Linked List contains `v` and optionally another parameter `w`. Here `u` and `v` are node(or vertex) labels and `w` is the weight of the edge. By Traversing the linked list we obtain the immediate neighbours of `u`. Visually, it looks like this. For implementing this in Python, we'll be using the dict()  for the main HashTable. For the Linked List we can use a list of 2 sized tuples (v,w).  Sidenote: Instead of a list of tuples, you can use a dict(), ...